global LEVEL_LINES_QUANTITY   
global MIN_LEVEL_LINES_TH MIN_FREQ_REF_TH
global OR_DEVIATION_DETECTION T K
global Fq R
global ORIENTATIONS_LEVELS_8


LEVEL_LINES_QUANTITY    = 48;
MIN_LEVEL_LINES_TH      = 2;
MIN_FREQ_REF_TH         = 0.4;
OR_DEVIATION_DETECTION  = 3;
ORIENTATIONS_LEVELS_8   = 8;
BACKGROUND_IN_SPEED     = 45;

file = 'vid_seq_0.avi';

mov = aviread(file);
numFrames = length(mov);

step = 1;
frameRate = 1;

T                       = frameRate * BACKGROUND_IN_SPEED / step;
K                       = T / (T+1);

capture = aviread(file,1);
[nlin,ncol,pipo] = size(capture.cdata);

Fq = zeros(nlin,ncol,ORIENTATIONS_LEVELS_8);
R = zeros(nlin,ncol,ORIENTATIONS_LEVELS_8);

MAX = numFrames;

for i=1:MAX
    i
    capture = aviread(file,i);
    frm = capture.cdata;
    
    frm_t = bilinearFilter(uint8(rgb2gray(frm)));
    
    [lc_t,oc_t] = getLevelLines(frm_t,ORIENTATIONS_LEVELS_8);
    lc_t = double(lc_t);
    oc_t = double(oc_t);
    [S_t,O_t] = getDetectionLines(lc_t,oc_t);

    subplot(1,3,1), imagesc(frm),axis off,title('Input Frame');
    cm = colormap;
    cm(1,:) = [1 1 1];
    colormap(cm);
    subplot(1,3,2), imagesc(S_t),axis off,title('S_t');
    subplot(1,3,3), imagesc(O_t),axis off,title('O_t');
    drawnow;

    updateReference(lc_t,oc_t);
    
end

